#include "../binary_c.h"
No_empty_translation_unit_warning;

#if defined NUCSYN

/*
 * Network code : NeNaMgAl
 * Automatically generated by make_reaction_network_code.pl
 */

/*
 * Species / Reactions list:
 *
 * 1 : H1 : -Ne20*H1*SIGMAV_T20 -Ne21*H1*SIGMAV_T21 -Ne22*H1*SIGMAV_T22 -Na23*H1*SIGMAV_T23 -Na23*H1*SIGMAV_T23P -Mg24*H1*SIGMAV_T24 -Mg25*H1*SIGMAV_T25 -Al26*H1*SIGMAV_T26P -Mg26*H1*SIGMAV_T26 -Al27*H1*SIGMAV_T27 -Al27*H1*SIGMAV_T27a
 * 2 : He4 : +Na23*H1*SIGMAV_T23 +Al27*H1*SIGMAV_T27a
 * 3 : Ne20 : -Ne20*H1*SIGMAV_T20 +Na23*H1*SIGMAV_T23
 * 4 : Ne21 : +Ne20*H1*SIGMAV_T20 -Ne21*H1*SIGMAV_T21
 * 5 : Ne22 : +Ne21*H1*SIGMAV_T21 -Ne22*H1*SIGMAV_T22
 * 6 : Na23 : +Ne22*H1*SIGMAV_T22 -Na23*H1*SIGMAV_T23 -Na23*H1*SIGMAV_T23P
 * 7 : Mg24 : +Na23*H1*SIGMAV_T23P -Mg24*H1*SIGMAV_T24 +Al27*H1*SIGMAV_T27a
 * 8 : Mg25 : +Mg24*H1*SIGMAV_T24 -Mg25*H1*SIGMAV_T25
 * 9 : Mg26 : +Al26*beta*SIGMAV_TBETA26 -Mg26*H1*SIGMAV_T26
 * 10 : Al26 : +Mg25*H1*SIGMAV_T25 -Al26*beta*SIGMAV_TBETA26 -Al26*H1*SIGMAV_T26P
 * 11 : Al27 : +Al26*H1*SIGMAV_T26P +Mg26*H1*SIGMAV_T26 -Al27*H1*SIGMAV_T27 -Al27*H1*SIGMAV_T27a
 * 12 : Si28 : +Al27*H1*SIGMAV_T27
 *
 */

static void NeNaMgAljacobian(double * const * const Restrict J,
                             const double * Restrict const N,
                             const double * Restrict const sigmav);

double nucsyn_burn_kaps_rentrop_NeNaMgAl(
    struct stardata_t * Restrict const stardata,
    double * Restrict const Nin,
    const double * Restrict const sigmav,
    const double h)
{
    double err;
    double ** JNeNaMgAl;

#define NSPECIES 12
    if(stardata->tmpstore->network_jacobians[NUCSYN_NETWORK_NeNaMgAl] == NULL)
    {
        Allocate_network_jacobian(NUCSYN_NETWORK_NeNaMgAl,
                                  NSPECIES);
    }

    JNeNaMgAl = stardata->tmpstore->network_jacobians[NUCSYN_NETWORK_NeNaMgAl];

    double yNeNaMgAl[NSPECIES+1],
        y2NeNaMgAl[NSPECIES+1],
        f1NeNaMgAl[NSPECIES+1],
        f2NeNaMgAl[NSPECIES+1],
        f3NeNaMgAl[NSPECIES+1],
        f4NeNaMgAl[NSPECIES+1];
    int indxNeNaMgAl[NSPECIES+1];

    yNeNaMgAl[1]=Nin[XH1];
    yNeNaMgAl[2]=Nin[XHe4];
    yNeNaMgAl[3]=Nin[XNe20];
    yNeNaMgAl[4]=Nin[XNe21];
    yNeNaMgAl[5]=Nin[XNe22];
    yNeNaMgAl[6]=Nin[XNa23];
    yNeNaMgAl[7]=Nin[XMg24];
    yNeNaMgAl[8]=Nin[XMg25];
    yNeNaMgAl[9]=Nin[XMg26];
    yNeNaMgAl[10]=Nin[XAl26];
    yNeNaMgAl[11]=Nin[XAl27];
    yNeNaMgAl[12]=Nin[XSi28];

    err = kaps_rentrop_GSL(stardata,
                           h,
                           yNeNaMgAl,
                           y2NeNaMgAl,
                           NSPECIES,
                           JNeNaMgAl,
                           sigmav,
                           Nin,
                           &NeNaMgAljacobian,
                           &NeNaMgAlderivatives,
                           f1NeNaMgAl,
                           f2NeNaMgAl,
                           f3NeNaMgAl,
                           f4NeNaMgAl,
                           stardata->preferences->nucsyn_network_error[NUCSYN_NETWORK_NeNaMgAl],
                           SOLUTION_MUST_BE_POSITIVE,
                           indxNeNaMgAl);

    if(err<=1.0)
    {
        Nin[XH1]=yNeNaMgAl[1];
        Nin[XHe4]=yNeNaMgAl[2];
        Nin[XNe20]=yNeNaMgAl[3];
        Nin[XNe21]=yNeNaMgAl[4];
        Nin[XNe22]=yNeNaMgAl[5];
        Nin[XNa23]=yNeNaMgAl[6];
        Nin[XMg24]=yNeNaMgAl[7];
        Nin[XMg25]=yNeNaMgAl[8];
        Nin[XMg26]=yNeNaMgAl[9];
        Nin[XAl26]=yNeNaMgAl[10];
        Nin[XAl27]=yNeNaMgAl[11];
        Nin[XSi28]=yNeNaMgAl[12];
    }

    return err;
}

void NeNaMgAlderivatives(const double * Restrict const y,double * Restrict const dydt,const double * Restrict const sigmav,const double * Restrict const N Maybe_unused)
{
    const double dummy0 = y[10] / sigmav[SIGMAV_TBETA26] ;
    const double dummy1 = y[11] * y[1] * sigmav[SIGMAV_T27a] ;
    const double dummy2 = y[4] * y[1] * sigmav[SIGMAV_T21] ;
    const double dummy3 = y[8] * y[1] * sigmav[SIGMAV_T25] ;
    const double dummy4 = y[7] * y[1] * sigmav[SIGMAV_T24] ;
    const double dummy5 = y[11] * y[1] * sigmav[SIGMAV_T27] ;
    const double dummy6 = y[9] * y[1] * sigmav[SIGMAV_T26] ;
    const double dummy7 = y[10] * y[1] * sigmav[SIGMAV_T26P] ;
    const double dummy8 = y[3] * y[1] * sigmav[SIGMAV_T20] ;
    const double dummy9 = y[6] * y[1] * sigmav[SIGMAV_T23P] ;
    const double dummy10 = y[5] * y[1] * sigmav[SIGMAV_T22] ;
    const double dummy11 = y[6] * y[1] * sigmav[SIGMAV_T23] ;
    dydt[1] = - dummy8  - dummy2  - dummy10  - dummy11  - dummy9  - dummy4  - dummy3  - dummy7  - dummy6  - dummy5  - dummy1 ;
    dydt[2] = + dummy11  + dummy1 ;
    dydt[3] = - dummy8  + dummy11 ;
    dydt[4] = + dummy8  - dummy2 ;
    dydt[5] = + dummy2  - dummy10 ;
    dydt[6] = + dummy10  - dummy11  - dummy9 ;
    dydt[7] =   dummy9  - dummy4  + dummy1 ;
    dydt[8] = + dummy4  - dummy3 ;
    dydt[9] = + dummy0  - dummy6 ;
    dydt[10] = - dummy0 + dummy3    - dummy7 ;
    dydt[11] = + dummy7  + dummy6  - dummy5  - dummy1 ;
    dydt[12] = + dummy5 ;
}


/*
 * Jacobian
 */
static void NeNaMgAljacobian(double *const*const Restrict J,
                             const double * Restrict const N,
                             const double * Restrict const sigmav)
{
    const double dummy0 = N[XH1] * sigmav[SIGMAV_T25] ;
    const double dummy1 = N[XNa23] * sigmav[SIGMAV_T23] ;
    const double dummy2 = N[XNa23] * sigmav[SIGMAV_T23P] ;
    const double dummy3 = N[XH1] * sigmav[SIGMAV_T26P] ;
    const double dummy4 = N[XH1] * sigmav[SIGMAV_T20] ;
    const double dummy5 = N[XAl27] * sigmav[SIGMAV_T27a] ;
    const double dummy6=1.0/sigmav[SIGMAV_TBETA26] ;
    const double dummy7 = N[XMg26] * sigmav[SIGMAV_T26] ;
    const double dummy8 = N[XH1] * sigmav[SIGMAV_T21] ;
    const double dummy9 = N[XMg25] * sigmav[SIGMAV_T25] ;
    const double dummy10 = N[XH1] * sigmav[SIGMAV_T23] ;
    const double dummy11 = N[XNe21] * sigmav[SIGMAV_T21] ;
    const double dummy12 = N[XAl27] * sigmav[SIGMAV_T27] ;
    const double dummy13 = N[XNe20] * sigmav[SIGMAV_T20] ;
    const double dummy14 = N[XH1] * sigmav[SIGMAV_T27] ;
    const double dummy15 = N[XH1] * sigmav[SIGMAV_T24] ;
    const double dummy16 = N[XH1] * sigmav[SIGMAV_T23P] ;
    const double dummy17 = N[XNe22] * sigmav[SIGMAV_T22] ;
    const double dummy18 = N[XH1] * sigmav[SIGMAV_T22] ;
    const double dummy19 = N[XH1] * sigmav[SIGMAV_T26] ;
    const double dummy20 = N[XMg24] * sigmav[SIGMAV_T24] ;
    const double dummy21 = N[XAl26] * sigmav[SIGMAV_T26P] ;
    const double dummy22 = N[XH1] * sigmav[SIGMAV_T27a] ;
    J[1][1] =  - dummy13  - dummy11  - dummy17  - dummy1  - dummy2  - dummy20  - dummy9  - dummy21  - dummy7  - dummy12  - dummy5 ;
    J[2][1] =  + dummy1  + dummy5 ;
    J[3][1] =  - dummy13  + dummy1 ;
    J[4][1] =  + dummy13  - dummy11 ;
    J[5][1] =  + dummy11  - dummy17 ;
    J[6][1] =  + dummy17  - dummy1  - dummy2 ;
    J[7][1] =  + dummy2  - dummy20  + dummy5 ;
    J[8][1] =  + dummy20  - dummy9 ;
    J[9][1] =  - dummy7 ;
    J[10][1] =  + dummy9  - dummy21 ;
    J[11][1] =  + dummy21  + dummy7  - dummy12  - dummy5 ;
    J[12][1] =  + dummy12 ;
    J[1][2] = 0.0;
    J[2][2] = 0.0;
    J[3][2] = 0.0;
    J[4][2] = 0.0;
    J[5][2] = 0.0;
    J[6][2] = 0.0;
    J[7][2] = 0.0;
    J[8][2] = 0.0;
    J[9][2] = 0.0;
    J[10][2] = 0.0;
    J[11][2] = 0.0;
    J[12][2] = 0.0;
    J[1][3] =  - dummy4 ;
    J[2][3] = 0.0;
    J[3][3] =  - dummy4 ;
    J[4][3] =  + dummy4 ;
    J[5][3] = 0.0;
    J[6][3] = 0.0;
    J[7][3] = 0.0;
    J[8][3] = 0.0;
    J[9][3] = 0.0;
    J[10][3] = 0.0;
    J[11][3] = 0.0;
    J[12][3] = 0.0;
    J[1][4] =  - dummy8 ;
    J[2][4] = 0.0;
    J[3][4] = 0.0;
    J[4][4] =  - dummy8 ;
    J[5][4] =  + dummy8 ;
    J[6][4] = 0.0;
    J[7][4] = 0.0;
    J[8][4] = 0.0;
    J[9][4] = 0.0;
    J[10][4] = 0.0;
    J[11][4] = 0.0;
    J[12][4] = 0.0;
    J[1][5] =  - dummy18 ;
    J[2][5] = 0.0;
    J[3][5] = 0.0;
    J[4][5] = 0.0;
    J[5][5] =  - dummy18 ;
    J[6][5] =  + dummy18 ;
    J[7][5] = 0.0;
    J[8][5] = 0.0;
    J[9][5] = 0.0;
    J[10][5] = 0.0;
    J[11][5] = 0.0;
    J[12][5] = 0.0;
    J[1][6] =  - dummy10  - dummy16 ;
    J[2][6] =  + dummy10 ;
    J[3][6] =  + dummy10 ;
    J[4][6] = 0.0;
    J[5][6] = 0.0;
    J[6][6] =  - dummy10  - dummy16 ;
    J[7][6] =  + dummy16 ;
    J[8][6] = 0.0;
    J[9][6] = 0.0;
    J[10][6] = 0.0;
    J[11][6] = 0.0;
    J[12][6] = 0.0;
    J[1][7] =  - dummy15 ;
    J[2][7] = 0.0;
    J[3][7] = 0.0;
    J[4][7] = 0.0;
    J[5][7] = 0.0;
    J[6][7] = 0.0;
    J[7][7] =  - dummy15 ;
    J[8][7] =  + dummy15 ;
    J[9][7] = 0.0;
    J[10][7] = 0.0;
    J[11][7] = 0.0;
    J[12][7] = 0.0;
    J[1][8] =  - dummy0 ;
    J[2][8] = 0.0;
    J[3][8] = 0.0;
    J[4][8] = 0.0;
    J[5][8] = 0.0;
    J[6][8] = 0.0;
    J[7][8] = 0.0;
    J[8][8] =  - dummy0 ;
    J[9][8] = 0.0;
    J[10][8] =  + dummy0 ;
    J[11][8] = 0.0;
    J[12][8] = 0.0;
    J[1][9] =  - dummy19 ;
    J[2][9] = 0.0;
    J[3][9] = 0.0;
    J[4][9] = 0.0;
    J[5][9] = 0.0;
    J[6][9] = 0.0;
    J[7][9] = 0.0;
    J[8][9] = 0.0;
    J[9][9] =  - dummy19 ;
    J[10][9] = 0.0;
    J[11][9] =  + dummy19 ;
    J[12][9] = 0.0;
    J[1][10] =  - dummy3 ;
    J[2][10] = 0.0;
    J[3][10] = 0.0;
    J[4][10] = 0.0;
    J[5][10] = 0.0;
    J[6][10] = 0.0;
    J[7][10] = 0.0;
    J[8][10] = 0.0;
    J[9][10] =  + dummy6 ;
    J[10][10] =  - dummy6  - dummy3 ;
    J[11][10] =  + dummy3 ;
    J[12][10] = 0.0;
    J[1][11] =  - dummy14  - dummy22 ;
    J[2][11] =  + dummy22 ;
    J[3][11] = 0.0;
    J[4][11] = 0.0;
    J[5][11] = 0.0;
    J[6][11] = 0.0;
    J[7][11] =  + dummy22 ;
    J[8][11] = 0.0;
    J[9][11] = 0.0;
    J[10][11] = 0.0;
    J[11][11] =  - dummy14  - dummy22 ;
    J[12][11] =  + dummy14 ;
    J[1][12] = 0.0;
    J[2][12] = 0.0;
    J[3][12] = 0.0;
    J[4][12] = 0.0;
    J[5][12] = 0.0;
    J[6][12] = 0.0;
    J[7][12] = 0.0;
    J[8][12] = 0.0;
    J[9][12] = 0.0;
    J[10][12] = 0.0;
    J[11][12] = 0.0;
    J[12][12] = 0.0;

}


#endif
